unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils,
  System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, GLWin32Viewer, GLObjects, GLGeomObjects,
  GLScene, GLCoordinates, GLCrossPlatform, BaseClasses, Vcl.ExtCtrls,
  Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    GLSceneViewer1: TGLSceneViewer;
    GLScene1: TGLScene;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    GLSphere1: TGLSphere;
    GLCylinder1: TGLCylinder;
    GLCube1: TGLCube;
    GLLightSource2: TGLLightSource;
    GLCamera2: TGLCamera;
    Panel1: TPanel;
    RadioGroup1: TRadioGroup;
    GLDummyCube1: TGLDummyCube;
    procedure RadioGroup1Click(Sender: TObject);
    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);

  private
    { Private declarations }
    x1, y1 : integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.GLSceneViewer1MouseDown(
  Sender: TObject;
  Button: TMouseButton;
  Shift : TShiftState;
  X, Y  : Integer);
begin
  x1 := X;
  y1 := Y;
end;

procedure TForm1.GLSceneViewer1MouseMove(
  Sender: TObject;
  Shift : TShiftState;
  X, Y  : Integer);
var
  dx, dy : integer;
begin
  if ssLeft in Shift then begin
    dx := X - x1;
    dy := Y - y1;

    GLCamera1.MoveAroundTarget(dy,dx);
    x1 := X;
    y1 := Y;
  end;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  if RadioGroup1.ItemIndex = 0
    then GLSceneViewer1.Camera := GLCamera1
    else GLSceneViewer1.Camera := GLCamera2

end;

end.
